/* Converted to D from oniguruma.h by htod */
module oniguruma;
//C     #ifndef ONIGURUMA_H
//C     #define ONIGURUMA_H
/**********************************************************************
  oniguruma.h - Oniguruma (regular expression library)
**********************************************************************/
/*-
 * Copyright (c) 2002-2007  K.Kosako  <sndgk393 AT ybb DOT ne DOT jp>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

//C     #ifdef __cplusplus
//C     extern "C" {
//C     #endif

//C     #define ONIGURUMA
//C     #define ONIGURUMA_VERSION_MAJOR   5
//C     #define ONIGURUMA_VERSION_MINOR   9
const ONIGURUMA_VERSION_MAJOR = 5;
//C     #define ONIGURUMA_VERSION_TEENY   1
const ONIGURUMA_VERSION_MINOR = 9;

const ONIGURUMA_VERSION_TEENY = 1;
//C     #ifdef __cplusplus
//C     # ifndef  HAVE_PROTOTYPES
//C     #  define HAVE_PROTOTYPES 1
//C     # endif
//C     # ifndef  HAVE_STDARG_PROTOTYPES
//C     #  define HAVE_STDARG_PROTOTYPES 1
//C     # endif
//C     #endif

/* escape Mac OS X/Xcode 2.4/gcc 4.0.1 problem */
//C     #if defined(__APPLE__) && defined(__GNUC__) && __GNUC__ >= 4
//C     # ifndef  HAVE_STDARG_PROTOTYPES
//C     #  define HAVE_STDARG_PROTOTYPES 1
//C     # endif
//C     #endif

//C     #ifdef HAVE_STDARG_H
//C     # ifndef  HAVE_STDARG_PROTOTYPES
//C     #  define HAVE_STDARG_PROTOTYPES 1
//C     # endif
//C     #endif

//C     #ifndef P_
//C     #if defined(__STDC__) || defined(_WIN32)
//C     # define P_(args) args
//C     #else
//C     # define P_(args) ()
//C     #endif
//C     #endif

//C     #ifndef PV_
//C     #ifdef HAVE_STDARG_PROTOTYPES
//C     # define PV_(args) args
//C     #else
//C     # define PV_(args) ()
//C     #endif
//C     #endif

//C     #ifndef ONIG_EXTERN
//C     #if defined(_WIN32) && !defined(__GNUC__)
//C     #if defined(EXPORT) || defined(RUBY_EXPORT)
//C     #define ONIG_EXTERN   extern __declspec(dllexport)
//C     #else
//C     #define ONIG_EXTERN   extern __declspec(dllimport)
//C     #endif
//C     #endif
//C     #endif

//C     #ifndef ONIG_EXTERN
//C     #define ONIG_EXTERN   extern
//C     #endif

/* PART: character encoding */

//C     #ifndef ONIG_ESCAPE_UCHAR_COLLISION
//C     #define UChar OnigUChar
//C     #endif
alias OnigUChar UChar;

//C     typedef unsigned char  OnigUChar;
extern (C):
alias ubyte OnigUChar;
//C     typedef unsigned long  OnigCodePoint;
alias uint OnigCodePoint;
//C     typedef unsigned int   OnigCtype;
alias uint OnigCtype;
//C     typedef unsigned int   OnigDistance;
alias uint OnigDistance;

//C     #define ONIG_INFINITE_DISTANCE  ~((OnigDistance )0)

//C     typedef unsigned int OnigCaseFoldType; /* case fold flag */
alias uint OnigCaseFoldType;

//C     ONIG_EXTERN OnigCaseFoldType OnigDefaultCaseFoldFlag;
extern export OnigCaseFoldType OnigDefaultCaseFoldFlag;

/* #define ONIGENC_CASE_FOLD_HIRAGANA_KATAKANA  (1<<1) */
/* #define ONIGENC_CASE_FOLD_KATAKANA_WIDTH     (1<<2) */
//C     #define ONIGENC_CASE_FOLD_TURKISH_AZERI         (1<<20)
//C     #define INTERNAL_ONIGENC_CASE_FOLD_MULTI_CHAR   (1<<30)

//C     #define ONIGENC_CASE_FOLD_MIN      INTERNAL_ONIGENC_CASE_FOLD_MULTI_CHAR
//C     #define ONIGENC_CASE_FOLD_DEFAULT  OnigDefaultCaseFoldFlag
const ONIGENC_CASE_FOLD_HIRAGANA_KATAKANA   = (1<<1);
const ONIGENC_CASE_FOLD_KATAKANA_WIDTH      = (1<<2);
const ONIGENC_CASE_FOLD_TURKISH_AZERI       = (1<<20);
const INTERNAL_ONIGENC_CASE_FOLD_MULTI_CHAR = (1<<30);

alias INTERNAL_ONIGENC_CASE_FOLD_MULTI_CHAR ONIGENC_CASE_FOLD_MIN;

alias OnigDefaultCaseFoldFlag ONIGENC_CASE_FOLD_DEFAULT;

//C     #define ONIGENC_MAX_COMP_CASE_FOLD_CODE_LEN       3
//C     #define ONIGENC_GET_CASE_FOLD_CODES_MAX_NUM      13
const ONIGENC_MAX_COMP_CASE_FOLD_CODE_LEN = 3;
/* 13 => Unicode:0x1ffc */
const ONIGENC_GET_CASE_FOLD_CODES_MAX_NUM = 13;

/* code range */
//C     #define ONIGENC_CODE_RANGE_NUM(range)     ((int )range[0])
//C     #define ONIGENC_CODE_RANGE_FROM(range,i)  range[((i)*2) + 1]
//C     #define ONIGENC_CODE_RANGE_TO(range,i)    range[((i)*2) + 2]

//C     typedef struct {
//C       int byte_len;  /* argument(original) character(s) byte length */
//C       int code_len;  /* number of code */
//C       OnigCodePoint code[ONIGENC_MAX_COMP_CASE_FOLD_CODE_LEN];
//C     } OnigCaseFoldCodeItem;
struct _N1
{
    int byte_len;
    int code_len;
    OnigCodePoint [3]code;
}
alias _N1 OnigCaseFoldCodeItem;

//C     typedef struct {
//C       OnigCodePoint esc;
//C       OnigCodePoint anychar;
//C       OnigCodePoint anytime;
//C       OnigCodePoint zero_or_one_time;
//C       OnigCodePoint one_or_more_time;
//C       OnigCodePoint anychar_anytime;
//C     } OnigMetaCharTableType;
struct _N2
{
    OnigCodePoint esc;
    OnigCodePoint anychar;
    OnigCodePoint anytime;
    OnigCodePoint zero_or_one_time;
    OnigCodePoint one_or_more_time;
    OnigCodePoint anychar_anytime;
}
alias _N2 OnigMetaCharTableType;
  
//C     typedef int (*OnigApplyAllCaseFoldFunc)(OnigCodePoint from, OnigCodePoint* to, int to_len, void* arg);
alias int  function(OnigCodePoint from, OnigCodePoint *to, int to_len, void *arg)OnigApplyAllCaseFoldFunc;

//C     typedef struct OnigEncodingTypeST {
//C       int    (*mbc_enc_len)(const OnigUChar* p);
//C       const char*   name;
//C       int           max_enc_len;
//C       int           min_enc_len;
//C       int    (*is_mbc_newline)(const OnigUChar* p, const OnigUChar* end);
//C       OnigCodePoint (*mbc_to_code)(const OnigUChar* p, const OnigUChar* end);
//C       int    (*code_to_mbclen)(OnigCodePoint code);
//C       int    (*code_to_mbc)(OnigCodePoint code, OnigUChar *buf);
//C       int    (*mbc_case_fold)(OnigCaseFoldType flag, const OnigUChar** pp, const OnigUChar* end, OnigUChar* to);
//C       int    (*apply_all_case_fold)(OnigCaseFoldType flag, OnigApplyAllCaseFoldFunc f, void* arg);
//C       int    (*get_case_fold_codes_by_str)(OnigCaseFoldType flag, const OnigUChar* p, const OnigUChar* end, OnigCaseFoldCodeItem acs[]);
//C       int    (*property_name_to_ctype)(struct OnigEncodingTypeST* enc, OnigUChar* p, OnigUChar* end);
//C       int    (*is_code_ctype)(OnigCodePoint code, OnigCtype ctype);
//C       int    (*get_ctype_code_range)(OnigCtype ctype, OnigCodePoint* sb_out, const OnigCodePoint* ranges[]);
//C       OnigUChar* (*left_adjust_char_head)(const OnigUChar* start, const OnigUChar* p);
//C       int    (*is_allowed_reverse_match)(const OnigUChar* p, const OnigUChar* end);
//C     } OnigEncodingType;
struct OnigEncodingTypeST
{
    int  function(OnigUChar *p)mbc_enc_len;
    char *name;
    int max_enc_len;
    int min_enc_len;
    int  function(OnigUChar *p, OnigUChar *end)is_mbc_newline;
    OnigCodePoint  function(OnigUChar *p, OnigUChar *end)mbc_to_code;
    int  function(OnigCodePoint code)code_to_mbclen;
    int  function(OnigCodePoint code, OnigUChar *buf)code_to_mbc;
    int  function(OnigCaseFoldType flag, OnigUChar **pp, OnigUChar *end, OnigUChar *to)mbc_case_fold;
    int  function(OnigCaseFoldType flag, OnigApplyAllCaseFoldFunc f, void *arg)apply_all_case_fold;
    int  function(OnigCaseFoldType flag, OnigUChar *p, OnigUChar *end, OnigCaseFoldCodeItem *acs)get_case_fold_codes_by_str;
    int  function(OnigEncodingTypeST *enc, OnigUChar *p, OnigUChar *end)property_name_to_ctype;
    int  function(OnigCodePoint code, OnigCtype ctype)is_code_ctype;
    int  function(OnigCtype ctype, OnigCodePoint *sb_out, OnigCodePoint **ranges)get_ctype_code_range;
    OnigUChar * function(OnigUChar *start, OnigUChar *p)left_adjust_char_head;
    int  function(OnigUChar *p, OnigUChar *end)is_allowed_reverse_match;
}
alias OnigEncodingTypeST OnigEncodingType;

//C     typedef OnigEncodingType* OnigEncoding;
alias OnigEncodingType *OnigEncoding;

//C     ONIG_EXTERN OnigEncodingType OnigEncodingASCII;
extern export OnigEncodingType OnigEncodingASCII;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingISO_8859_1;
extern export OnigEncodingType OnigEncodingISO_8859_1;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingISO_8859_2;
extern export OnigEncodingType OnigEncodingISO_8859_2;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingISO_8859_3;
extern export OnigEncodingType OnigEncodingISO_8859_3;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingISO_8859_4;
extern export OnigEncodingType OnigEncodingISO_8859_4;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingISO_8859_5;
extern export OnigEncodingType OnigEncodingISO_8859_5;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingISO_8859_6;
extern export OnigEncodingType OnigEncodingISO_8859_6;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingISO_8859_7;
extern export OnigEncodingType OnigEncodingISO_8859_7;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingISO_8859_8;
extern export OnigEncodingType OnigEncodingISO_8859_8;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingISO_8859_9;
extern export OnigEncodingType OnigEncodingISO_8859_9;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingISO_8859_10;
extern export OnigEncodingType OnigEncodingISO_8859_10;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingISO_8859_11;
extern export OnigEncodingType OnigEncodingISO_8859_11;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingISO_8859_13;
extern export OnigEncodingType OnigEncodingISO_8859_13;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingISO_8859_14;
extern export OnigEncodingType OnigEncodingISO_8859_14;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingISO_8859_15;
extern export OnigEncodingType OnigEncodingISO_8859_15;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingISO_8859_16;
extern export OnigEncodingType OnigEncodingISO_8859_16;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingUTF8;
extern export OnigEncodingType OnigEncodingUTF8;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingUTF16_BE;
extern export OnigEncodingType OnigEncodingUTF16_BE;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingUTF16_LE;
extern export OnigEncodingType OnigEncodingUTF16_LE;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingUTF32_BE;
extern export OnigEncodingType OnigEncodingUTF32_BE;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingUTF32_LE;
extern export OnigEncodingType OnigEncodingUTF32_LE;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingEUC_JP;
extern export OnigEncodingType OnigEncodingEUC_JP;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingEUC_TW;
extern export OnigEncodingType OnigEncodingEUC_TW;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingEUC_KR;
extern export OnigEncodingType OnigEncodingEUC_KR;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingEUC_CN;
extern export OnigEncodingType OnigEncodingEUC_CN;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingSJIS;
extern export OnigEncodingType OnigEncodingSJIS;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingKOI8;
extern export OnigEncodingType OnigEncodingKOI8;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingKOI8_R;
extern export OnigEncodingType OnigEncodingKOI8_R;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingCP1251;
extern export OnigEncodingType OnigEncodingCP1251;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingBIG5;
extern export OnigEncodingType OnigEncodingBIG5;
//C     ONIG_EXTERN OnigEncodingType OnigEncodingGB18030;
extern export OnigEncodingType OnigEncodingGB18030;

//C     #define ONIG_ENCODING_ASCII        (&OnigEncodingASCII)
//C     #define ONIG_ENCODING_ISO_8859_1   (&OnigEncodingISO_8859_1)
//C     #define ONIG_ENCODING_ISO_8859_2   (&OnigEncodingISO_8859_2)
//C     #define ONIG_ENCODING_ISO_8859_3   (&OnigEncodingISO_8859_3)
//C     #define ONIG_ENCODING_ISO_8859_4   (&OnigEncodingISO_8859_4)
//C     #define ONIG_ENCODING_ISO_8859_5   (&OnigEncodingISO_8859_5)
//C     #define ONIG_ENCODING_ISO_8859_6   (&OnigEncodingISO_8859_6)
//C     #define ONIG_ENCODING_ISO_8859_7   (&OnigEncodingISO_8859_7)
//C     #define ONIG_ENCODING_ISO_8859_8   (&OnigEncodingISO_8859_8)
//C     #define ONIG_ENCODING_ISO_8859_9   (&OnigEncodingISO_8859_9)
//C     #define ONIG_ENCODING_ISO_8859_10  (&OnigEncodingISO_8859_10)
//C     #define ONIG_ENCODING_ISO_8859_11  (&OnigEncodingISO_8859_11)
//C     #define ONIG_ENCODING_ISO_8859_13  (&OnigEncodingISO_8859_13)
//C     #define ONIG_ENCODING_ISO_8859_14  (&OnigEncodingISO_8859_14)
//C     #define ONIG_ENCODING_ISO_8859_15  (&OnigEncodingISO_8859_15)
//C     #define ONIG_ENCODING_ISO_8859_16  (&OnigEncodingISO_8859_16)
//C     #define ONIG_ENCODING_UTF8         (&OnigEncodingUTF8)
//C     #define ONIG_ENCODING_UTF16_BE     (&OnigEncodingUTF16_BE)
//C     #define ONIG_ENCODING_UTF16_LE     (&OnigEncodingUTF16_LE)
//C     #define ONIG_ENCODING_UTF32_BE     (&OnigEncodingUTF32_BE)
//C     #define ONIG_ENCODING_UTF32_LE     (&OnigEncodingUTF32_LE)
//C     #define ONIG_ENCODING_EUC_JP       (&OnigEncodingEUC_JP)
//C     #define ONIG_ENCODING_EUC_TW       (&OnigEncodingEUC_TW)
//C     #define ONIG_ENCODING_EUC_KR       (&OnigEncodingEUC_KR)
//C     #define ONIG_ENCODING_EUC_CN       (&OnigEncodingEUC_CN)
//C     #define ONIG_ENCODING_SJIS         (&OnigEncodingSJIS)
//C     #define ONIG_ENCODING_KOI8         (&OnigEncodingKOI8)
//C     #define ONIG_ENCODING_KOI8_R       (&OnigEncodingKOI8_R)
//C     #define ONIG_ENCODING_CP1251       (&OnigEncodingCP1251)
//C     #define ONIG_ENCODING_BIG5         (&OnigEncodingBIG5)
//C     #define ONIG_ENCODING_GB18030      (&OnigEncodingGB18030)

//C     #define ONIG_ENCODING_UNDEF    ((OnigEncoding )0)

/* work size */
//C     #define ONIGENC_CODE_TO_MBC_MAXLEN       7
//C     #define ONIGENC_MBC_CASE_FOLD_MAXLEN    18
const ONIGENC_CODE_TO_MBC_MAXLEN = 7;
/* 18: 6(max-byte) * 3(case-fold chars) */
const ONIGENC_MBC_CASE_FOLD_MAXLEN = 18;

/* character types */
//C     #define ONIGENC_CTYPE_NEWLINE   0
//C     #define ONIGENC_CTYPE_ALPHA     1
const ONIGENC_CTYPE_NEWLINE = 0;
//C     #define ONIGENC_CTYPE_BLANK     2
const ONIGENC_CTYPE_ALPHA = 1;
//C     #define ONIGENC_CTYPE_CNTRL     3
const ONIGENC_CTYPE_BLANK = 2;
//C     #define ONIGENC_CTYPE_DIGIT     4
const ONIGENC_CTYPE_CNTRL = 3;
//C     #define ONIGENC_CTYPE_GRAPH     5
const ONIGENC_CTYPE_DIGIT = 4;
//C     #define ONIGENC_CTYPE_LOWER     6
const ONIGENC_CTYPE_GRAPH = 5;
//C     #define ONIGENC_CTYPE_PRINT     7
const ONIGENC_CTYPE_LOWER = 6;
//C     #define ONIGENC_CTYPE_PUNCT     8
const ONIGENC_CTYPE_PRINT = 7;
//C     #define ONIGENC_CTYPE_SPACE     9
const ONIGENC_CTYPE_PUNCT = 8;
//C     #define ONIGENC_CTYPE_UPPER    10
const ONIGENC_CTYPE_SPACE = 9;
//C     #define ONIGENC_CTYPE_XDIGIT   11
const ONIGENC_CTYPE_UPPER = 10;
//C     #define ONIGENC_CTYPE_WORD     12
const ONIGENC_CTYPE_XDIGIT = 11;
//C     #define ONIGENC_CTYPE_ALNUM    13  /* alpha || digit */
const ONIGENC_CTYPE_WORD = 12;
//C     #define ONIGENC_CTYPE_ASCII    14
const ONIGENC_CTYPE_ALNUM = 13;
//C     #define ONIGENC_MAX_STD_CTYPE  ONIGENC_CTYPE_ASCII
const ONIGENC_CTYPE_ASCII = 14;

alias ONIGENC_CTYPE_ASCII ONIGENC_MAX_STD_CTYPE;

//C     #define onig_enc_len(enc,p,end)        ONIGENC_MBC_ENC_LEN(enc,p)

//C     #define ONIGENC_IS_UNDEF(enc)          ((enc) == ONIG_ENCODING_UNDEF)
//C     #define ONIGENC_IS_SINGLEBYTE(enc)     (ONIGENC_MBC_MAXLEN(enc) == 1)
//C     #define ONIGENC_IS_MBC_HEAD(enc,p)     (ONIGENC_MBC_ENC_LEN(enc,p) != 1)
//C     #define ONIGENC_IS_MBC_ASCII(p)           (*(p)   < 128)
//C     #define ONIGENC_IS_CODE_ASCII(code)       ((code) < 128)
//C     #define ONIGENC_IS_MBC_WORD(enc,s,end)    ONIGENC_IS_CODE_WORD(enc,ONIGENC_MBC_TO_CODE(enc,s,end))


//C     #define ONIGENC_NAME(enc)                      ((enc)->name)

//C     #define ONIGENC_MBC_CASE_FOLD(enc,flag,pp,end,buf)   (enc)->mbc_case_fold(flag,(const OnigUChar** )pp,end,buf)
//C     #define ONIGENC_IS_ALLOWED_REVERSE_MATCH(enc,s,end)         (enc)->is_allowed_reverse_match(s,end)
//C     #define ONIGENC_LEFT_ADJUST_CHAR_HEAD(enc,start,s)         (enc)->left_adjust_char_head(start, s)
//C     #define ONIGENC_APPLY_ALL_CASE_FOLD(enc,case_fold_flag,f,arg)         (enc)->apply_all_case_fold(case_fold_flag,f,arg)
//C     #define ONIGENC_GET_CASE_FOLD_CODES_BY_STR(enc,case_fold_flag,p,end,acs)        (enc)->get_case_fold_codes_by_str(case_fold_flag,p,end,acs)
//C     #define ONIGENC_STEP_BACK(enc,start,s,n)         onigenc_step_back((enc),(start),(s),(n))

//C     #define ONIGENC_MBC_ENC_LEN(enc,p)             (enc)->mbc_enc_len(p)
//C     #define ONIGENC_MBC_MAXLEN(enc)               ((enc)->max_enc_len)
//C     #define ONIGENC_MBC_MAXLEN_DIST(enc)           ONIGENC_MBC_MAXLEN(enc)
//C     #define ONIGENC_MBC_MINLEN(enc)               ((enc)->min_enc_len)
//C     #define ONIGENC_IS_MBC_NEWLINE(enc,p,end)      (enc)->is_mbc_newline((p),(end))
//C     #define ONIGENC_MBC_TO_CODE(enc,p,end)         (enc)->mbc_to_code((p),(end))
//C     #define ONIGENC_CODE_TO_MBCLEN(enc,code)       (enc)->code_to_mbclen(code)
//C     #define ONIGENC_CODE_TO_MBC(enc,code,buf)      (enc)->code_to_mbc(code,buf)
//C     #define ONIGENC_PROPERTY_NAME_TO_CTYPE(enc,p,end)   (enc)->property_name_to_ctype(enc,p,end)

//C     #define ONIGENC_IS_CODE_CTYPE(enc,code,ctype)  (enc)->is_code_ctype(code,ctype)

//C     #define ONIGENC_IS_CODE_NEWLINE(enc,code)         ONIGENC_IS_CODE_CTYPE(enc,code,ONIGENC_CTYPE_NEWLINE)
//C     #define ONIGENC_IS_CODE_GRAPH(enc,code)         ONIGENC_IS_CODE_CTYPE(enc,code,ONIGENC_CTYPE_GRAPH)
//C     #define ONIGENC_IS_CODE_PRINT(enc,code)         ONIGENC_IS_CODE_CTYPE(enc,code,ONIGENC_CTYPE_PRINT)
//C     #define ONIGENC_IS_CODE_ALNUM(enc,code)         ONIGENC_IS_CODE_CTYPE(enc,code,ONIGENC_CTYPE_ALNUM)
//C     #define ONIGENC_IS_CODE_ALPHA(enc,code)         ONIGENC_IS_CODE_CTYPE(enc,code,ONIGENC_CTYPE_ALPHA)
//C     #define ONIGENC_IS_CODE_LOWER(enc,code)         ONIGENC_IS_CODE_CTYPE(enc,code,ONIGENC_CTYPE_LOWER)
//C     #define ONIGENC_IS_CODE_UPPER(enc,code)         ONIGENC_IS_CODE_CTYPE(enc,code,ONIGENC_CTYPE_UPPER)
//C     #define ONIGENC_IS_CODE_CNTRL(enc,code)         ONIGENC_IS_CODE_CTYPE(enc,code,ONIGENC_CTYPE_CNTRL)
//C     #define ONIGENC_IS_CODE_PUNCT(enc,code)         ONIGENC_IS_CODE_CTYPE(enc,code,ONIGENC_CTYPE_PUNCT)
//C     #define ONIGENC_IS_CODE_SPACE(enc,code)         ONIGENC_IS_CODE_CTYPE(enc,code,ONIGENC_CTYPE_SPACE)
//C     #define ONIGENC_IS_CODE_BLANK(enc,code)         ONIGENC_IS_CODE_CTYPE(enc,code,ONIGENC_CTYPE_BLANK)
//C     #define ONIGENC_IS_CODE_DIGIT(enc,code)         ONIGENC_IS_CODE_CTYPE(enc,code,ONIGENC_CTYPE_DIGIT)
//C     #define ONIGENC_IS_CODE_XDIGIT(enc,code)         ONIGENC_IS_CODE_CTYPE(enc,code,ONIGENC_CTYPE_XDIGIT)
//C     #define ONIGENC_IS_CODE_WORD(enc,code)         ONIGENC_IS_CODE_CTYPE(enc,code,ONIGENC_CTYPE_WORD)

//C     #define ONIGENC_GET_CTYPE_CODE_RANGE(enc,ctype,sbout,ranges)         (enc)->get_ctype_code_range(ctype,sbout,ranges)

//C     ONIG_EXTERN
//C     OnigUChar* onigenc_step_back P_((OnigEncoding enc, const OnigUChar* start, const OnigUChar* s, int n));
OnigUChar * onigenc_step_back(OnigEncoding enc, OnigUChar *start, OnigUChar *s, int n);


/* encoding API */
//C     ONIG_EXTERN
//C     int onigenc_init P_((void));
int  onigenc_init();
//C     ONIG_EXTERN
//C     int onigenc_set_default_encoding P_((OnigEncoding enc));
int  onigenc_set_default_encoding(OnigEncoding enc);
//C     ONIG_EXTERN
//C     OnigEncoding onigenc_get_default_encoding P_((void));
OnigEncoding  onigenc_get_default_encoding();
//C     ONIG_EXTERN
//C     void  onigenc_set_default_caseconv_table P_((const OnigUChar* table));
void  onigenc_set_default_caseconv_table(OnigUChar *table);
//C     ONIG_EXTERN
//C     OnigUChar* onigenc_get_right_adjust_char_head_with_prev P_((OnigEncoding enc, const OnigUChar* start, const OnigUChar* s, const OnigUChar** prev));
OnigUChar * onigenc_get_right_adjust_char_head_with_prev(OnigEncoding enc, OnigUChar *start, OnigUChar *s, OnigUChar **prev);
//C     ONIG_EXTERN
//C     OnigUChar* onigenc_get_prev_char_head P_((OnigEncoding enc, const OnigUChar* start, const OnigUChar* s));
OnigUChar * onigenc_get_prev_char_head(OnigEncoding enc, OnigUChar *start, OnigUChar *s);
//C     ONIG_EXTERN
//C     OnigUChar* onigenc_get_left_adjust_char_head P_((OnigEncoding enc, const OnigUChar* start, const OnigUChar* s));
OnigUChar * onigenc_get_left_adjust_char_head(OnigEncoding enc, OnigUChar *start, OnigUChar *s);
//C     ONIG_EXTERN
//C     OnigUChar* onigenc_get_right_adjust_char_head P_((OnigEncoding enc, const OnigUChar* start, const OnigUChar* s));
OnigUChar * onigenc_get_right_adjust_char_head(OnigEncoding enc, OnigUChar *start, OnigUChar *s);
//C     ONIG_EXTERN
//C     int onigenc_strlen P_((OnigEncoding enc, const OnigUChar* p, const OnigUChar* end));
int  onigenc_strlen(OnigEncoding enc, OnigUChar *p, OnigUChar *end);
//C     ONIG_EXTERN
//C     int onigenc_strlen_null P_((OnigEncoding enc, const OnigUChar* p));
int  onigenc_strlen_null(OnigEncoding enc, OnigUChar *p);
//C     ONIG_EXTERN
//C     int onigenc_str_bytelen_null P_((OnigEncoding enc, const OnigUChar* p));
int  onigenc_str_bytelen_null(OnigEncoding enc, OnigUChar *p);



/* PART: regular expression */

/* config parameters */
//C     #define ONIG_NREGION                          10
//C     #define ONIG_MAX_BACKREF_NUM                1000
const ONIG_NREGION = 10;
//C     #define ONIG_MAX_REPEAT_NUM               100000
const ONIG_MAX_BACKREF_NUM = 1000;
//C     #define ONIG_MAX_MULTI_BYTE_RANGES_NUM     10000
const ONIG_MAX_REPEAT_NUM = 100000;
/* constants */
const ONIG_MAX_MULTI_BYTE_RANGES_NUM = 10000;
//C     #define ONIG_MAX_ERROR_MESSAGE_LEN            90

const ONIG_MAX_ERROR_MESSAGE_LEN = 90;
//C     typedef unsigned int        OnigOptionType;
alias uint OnigOptionType;

//C     #define ONIG_OPTION_DEFAULT            ONIG_OPTION_NONE

/* options */
//C     #define ONIG_OPTION_NONE                 0U
//C     #define ONIG_OPTION_IGNORECASE           1U
const ONIG_OPTION_NONE = 0U;
alias ONIG_OPTION_NONE ONIG_OPTION_DEFAULT;
const ONIG_OPTION_IGNORECASE = 1U;
//C     #define ONIG_OPTION_EXTEND               (ONIG_OPTION_IGNORECASE         << 1)
//C     #define ONIG_OPTION_MULTILINE            (ONIG_OPTION_EXTEND             << 1)
//C     #define ONIG_OPTION_SINGLELINE           (ONIG_OPTION_MULTILINE          << 1)
//C     #define ONIG_OPTION_FIND_LONGEST         (ONIG_OPTION_SINGLELINE         << 1)
//C     #define ONIG_OPTION_FIND_NOT_EMPTY       (ONIG_OPTION_FIND_LONGEST       << 1)
//C     #define ONIG_OPTION_NEGATE_SINGLELINE    (ONIG_OPTION_FIND_NOT_EMPTY     << 1)
//C     #define ONIG_OPTION_DONT_CAPTURE_GROUP   (ONIG_OPTION_NEGATE_SINGLELINE  << 1)
//C     #define ONIG_OPTION_CAPTURE_GROUP        (ONIG_OPTION_DONT_CAPTURE_GROUP << 1)
/* options (search time) */
//C     #define ONIG_OPTION_NOTBOL               (ONIG_OPTION_CAPTURE_GROUP << 1)
//C     #define ONIG_OPTION_NOTEOL               (ONIG_OPTION_NOTBOL << 1)
//C     #define ONIG_OPTION_POSIX_REGION         (ONIG_OPTION_NOTEOL << 1)
//C     #define ONIG_OPTION_MAXBIT               ONIG_OPTION_POSIX_REGION  /* limit */
const ONIG_OPTION_EXTEND               = (ONIG_OPTION_IGNORECASE         << 1);
const ONIG_OPTION_MULTILINE            = (ONIG_OPTION_EXTEND             << 1);
const ONIG_OPTION_SINGLELINE           = (ONIG_OPTION_MULTILINE          << 1);
const ONIG_OPTION_FIND_LONGEST         = (ONIG_OPTION_SINGLELINE         << 1);
const ONIG_OPTION_FIND_NOT_EMPTY       = (ONIG_OPTION_FIND_LONGEST       << 1);
const ONIG_OPTION_NEGATE_SINGLELINE    = (ONIG_OPTION_FIND_NOT_EMPTY     << 1);
const ONIG_OPTION_DONT_CAPTURE_GROUP   = (ONIG_OPTION_NEGATE_SINGLELINE  << 1);
const ONIG_OPTION_CAPTURE_GROUP        = (ONIG_OPTION_DONT_CAPTURE_GROUP << 1);
/* options (search time) */
const ONIG_OPTION_NOTBOL               = (ONIG_OPTION_CAPTURE_GROUP << 1);
const ONIG_OPTION_NOTEOL               = (ONIG_OPTION_NOTBOL << 1);
const ONIG_OPTION_POSIX_REGION         = (ONIG_OPTION_NOTEOL << 1);

alias ONIG_OPTION_POSIX_REGION ONIG_OPTION_MAXBIT;
//C     #define ONIG_OPTION_ON(options,regopt)      ((options) |= (regopt))
//C     #define ONIG_OPTION_OFF(options,regopt)     ((options) &= ~(regopt))
//C     #define ONIG_IS_OPTION_ON(options,option)   ((options) & (option))
    uint ONIG_OPTION_ON(uint options, uint regopt){      return ((options) |= (regopt));}
    uint ONIG_OPTION_OFF(uint options, uint regopt){     return ((options) &= ~(regopt));}
    uint ONIG_IS_OPTION_ON(uint options, uint option){   return ((options) & (option));}

/* syntax */
//C     typedef struct {
//C       unsigned int   op;
//C       unsigned int   op2;
//C       unsigned int   behavior;
//C       OnigOptionType options;   /* default option */
//C       OnigMetaCharTableType meta_char_table;
//C     } OnigSyntaxType;
struct _N3
{
    uint op;
    uint op2;
    uint behavior;
    OnigOptionType options;
    OnigMetaCharTableType meta_char_table;
}
alias _N3 OnigSyntaxType;

//C     ONIG_EXTERN OnigSyntaxType OnigSyntaxASIS;
extern export OnigSyntaxType OnigSyntaxASIS;
//C     ONIG_EXTERN OnigSyntaxType OnigSyntaxPosixBasic;
extern export OnigSyntaxType OnigSyntaxPosixBasic;
//C     ONIG_EXTERN OnigSyntaxType OnigSyntaxPosixExtended;
extern export OnigSyntaxType OnigSyntaxPosixExtended;
//C     ONIG_EXTERN OnigSyntaxType OnigSyntaxEmacs;
extern export OnigSyntaxType OnigSyntaxEmacs;
//C     ONIG_EXTERN OnigSyntaxType OnigSyntaxGrep;
extern export OnigSyntaxType OnigSyntaxGrep;
//C     ONIG_EXTERN OnigSyntaxType OnigSyntaxGnuRegex;
extern export OnigSyntaxType OnigSyntaxGnuRegex;
//C     ONIG_EXTERN OnigSyntaxType OnigSyntaxJava;
extern export OnigSyntaxType OnigSyntaxJava;
//C     ONIG_EXTERN OnigSyntaxType OnigSyntaxPerl;
extern export OnigSyntaxType OnigSyntaxPerl;
//C     ONIG_EXTERN OnigSyntaxType OnigSyntaxPerl_NG;
extern export OnigSyntaxType OnigSyntaxPerl_NG;
//C     ONIG_EXTERN OnigSyntaxType OnigSyntaxRuby;
extern export OnigSyntaxType OnigSyntaxRuby;

/* predefined syntaxes (see regsyntax.c) */
//C     #define ONIG_SYNTAX_ASIS               (&OnigSyntaxASIS)
//C     #define ONIG_SYNTAX_POSIX_BASIC        (&OnigSyntaxPosixBasic)
//C     #define ONIG_SYNTAX_POSIX_EXTENDED     (&OnigSyntaxPosixExtended)
//C     #define ONIG_SYNTAX_EMACS              (&OnigSyntaxEmacs)
//C     #define ONIG_SYNTAX_GREP               (&OnigSyntaxGrep)
//C     #define ONIG_SYNTAX_GNU_REGEX          (&OnigSyntaxGnuRegex)
//C     #define ONIG_SYNTAX_JAVA               (&OnigSyntaxJava)
//C     #define ONIG_SYNTAX_PERL               (&OnigSyntaxPerl)
//C     #define ONIG_SYNTAX_PERL_NG            (&OnigSyntaxPerl_NG)
//C     #define ONIG_SYNTAX_RUBY               (&OnigSyntaxRuby)

/* default syntax */
//C     ONIG_EXTERN OnigSyntaxType*   OnigDefaultSyntax;
extern export OnigSyntaxType *OnigDefaultSyntax;
//C     #define ONIG_SYNTAX_DEFAULT   OnigDefaultSyntax

alias OnigDefaultSyntax ONIG_SYNTAX_DEFAULT;
/* syntax (operators) */
//C     #define ONIG_SYN_OP_VARIABLE_META_CHARACTERS    (1U<<0)
//C     #define ONIG_SYN_OP_DOT_ANYCHAR                 (1U<<1)   /* . */
//C     #define ONIG_SYN_OP_ASTERISK_ZERO_INF           (1U<<2)   /* * */
//C     #define ONIG_SYN_OP_ESC_ASTERISK_ZERO_INF       (1U<<3)
//C     #define ONIG_SYN_OP_PLUS_ONE_INF                (1U<<4)   /* + */
//C     #define ONIG_SYN_OP_ESC_PLUS_ONE_INF            (1U<<5)
//C     #define ONIG_SYN_OP_QMARK_ZERO_ONE              (1U<<6)   /* ? */
//C     #define ONIG_SYN_OP_ESC_QMARK_ZERO_ONE          (1U<<7)
//C     #define ONIG_SYN_OP_BRACE_INTERVAL              (1U<<8)   /* {lower,upper} */
//C     #define ONIG_SYN_OP_ESC_BRACE_INTERVAL          (1U<<9)   /* \{lower,upper\} */
//C     #define ONIG_SYN_OP_VBAR_ALT                    (1U<<10)   /* | */
//C     #define ONIG_SYN_OP_ESC_VBAR_ALT                (1U<<11)  /* \| */
//C     #define ONIG_SYN_OP_LPAREN_SUBEXP               (1U<<12)  /* (...)   */
//C     #define ONIG_SYN_OP_ESC_LPAREN_SUBEXP           (1U<<13)  /* \(...\) */
//C     #define ONIG_SYN_OP_ESC_AZ_BUF_ANCHOR           (1U<<14)  /* \A, \Z, \z */
//C     #define ONIG_SYN_OP_ESC_CAPITAL_G_BEGIN_ANCHOR  (1U<<15)  /* \G     */
//C     #define ONIG_SYN_OP_DECIMAL_BACKREF             (1U<<16)  /* \num   */
//C     #define ONIG_SYN_OP_BRACKET_CC                  (1U<<17)  /* [...]  */
//C     #define ONIG_SYN_OP_ESC_W_WORD                  (1U<<18)  /* \w, \W */
//C     #define ONIG_SYN_OP_ESC_LTGT_WORD_BEGIN_END     (1U<<19)  /* \<. \> */
//C     #define ONIG_SYN_OP_ESC_B_WORD_BOUND            (1U<<20)  /* \b, \B */
//C     #define ONIG_SYN_OP_ESC_S_WHITE_SPACE           (1U<<21)  /* \s, \S */
//C     #define ONIG_SYN_OP_ESC_D_DIGIT                 (1U<<22)  /* \d, \D */
//C     #define ONIG_SYN_OP_LINE_ANCHOR                 (1U<<23)  /* ^, $   */
//C     #define ONIG_SYN_OP_POSIX_BRACKET               (1U<<24)  /* [:xxxx:] */
//C     #define ONIG_SYN_OP_QMARK_NON_GREEDY            (1U<<25)  /* ??,*?,+?,{n,m}? */
//C     #define ONIG_SYN_OP_ESC_CONTROL_CHARS           (1U<<26)  /* \n,\r,\t,\a ... */
//C     #define ONIG_SYN_OP_ESC_C_CONTROL               (1U<<27)  /* \cx  */
//C     #define ONIG_SYN_OP_ESC_OCTAL3                  (1U<<28)  /* \OOO */
//C     #define ONIG_SYN_OP_ESC_X_HEX2                  (1U<<29)  /* \xHH */
//C     #define ONIG_SYN_OP_ESC_X_BRACE_HEX8            (1U<<30)  /* \x{7HHHHHHH} */

//C     #define ONIG_SYN_OP2_ESC_CAPITAL_Q_QUOTE        (1U<<0)  /* \Q...\E */
//C     #define ONIG_SYN_OP2_QMARK_GROUP_EFFECT         (1U<<1)  /* (?...) */
//C     #define ONIG_SYN_OP2_OPTION_PERL                (1U<<2)  /* (?imsx),(?-imsx) */
//C     #define ONIG_SYN_OP2_OPTION_RUBY                (1U<<3)  /* (?imx), (?-imx)  */
//C     #define ONIG_SYN_OP2_PLUS_POSSESSIVE_REPEAT     (1U<<4)  /* ?+,*+,++ */
//C     #define ONIG_SYN_OP2_PLUS_POSSESSIVE_INTERVAL   (1U<<5)  /* {n,m}+   */
//C     #define ONIG_SYN_OP2_CCLASS_SET_OP              (1U<<6)  /* [...&&..[..]..] */
//C     #define ONIG_SYN_OP2_QMARK_LT_NAMED_GROUP       (1U<<7)  /* (?<name>...) */
//C     #define ONIG_SYN_OP2_ESC_K_NAMED_BACKREF        (1U<<8)  /* \k<name> */
//C     #define ONIG_SYN_OP2_ESC_G_SUBEXP_CALL          (1U<<9)  /* \g<name>, \g<n> */
//C     #define ONIG_SYN_OP2_ATMARK_CAPTURE_HISTORY     (1U<<10) /* (?@..),(?@<x>..) */
//C     #define ONIG_SYN_OP2_ESC_CAPITAL_C_BAR_CONTROL  (1U<<11) /* \C-x */
//C     #define ONIG_SYN_OP2_ESC_CAPITAL_M_BAR_META     (1U<<12) /* \M-x */
//C     #define ONIG_SYN_OP2_ESC_V_VTAB                 (1U<<13) /* \v as VTAB */
//C     #define ONIG_SYN_OP2_ESC_U_HEX4                 (1U<<14) /* \uHHHH */
//C     #define ONIG_SYN_OP2_ESC_GNU_BUF_ANCHOR         (1U<<15) /* \`, \' */
//C     #define ONIG_SYN_OP2_ESC_P_BRACE_CHAR_PROPERTY  (1U<<16) /* \p{...}, \P{...} */
//C     #define ONIG_SYN_OP2_ESC_P_BRACE_CIRCUMFLEX_NOT (1U<<17) /* \p{^..}, \P{^..} */
/* #define ONIG_SYN_OP2_CHAR_PROPERTY_PREFIX_IS (1U<<18) */
//C     #define ONIG_SYN_OP2_ESC_H_XDIGIT               (1U<<19) /* \h, \H */
//C     #define ONIG_SYN_OP2_INEFFECTIVE_ESCAPE         (1U<<20) /* \ */

/* syntax (behavior) */
//C     #define ONIG_SYN_CONTEXT_INDEP_ANCHORS           (1U<<31) /* not implemented */
//C     #define ONIG_SYN_CONTEXT_INDEP_REPEAT_OPS        (1U<<0)  /* ?, *, +, {n,m} */
//C     #define ONIG_SYN_CONTEXT_INVALID_REPEAT_OPS      (1U<<1)  /* error or ignore */
//C     #define ONIG_SYN_ALLOW_UNMATCHED_CLOSE_SUBEXP    (1U<<2)  /* ...)... */
//C     #define ONIG_SYN_ALLOW_INVALID_INTERVAL          (1U<<3)  /* {??? */
//C     #define ONIG_SYN_ALLOW_INTERVAL_LOW_ABBREV       (1U<<4)  /* {,n} => {0,n} */
//C     #define ONIG_SYN_STRICT_CHECK_BACKREF            (1U<<5)  /* /(\1)/,/\1()/ ..*/
//C     #define ONIG_SYN_DIFFERENT_LEN_ALT_LOOK_BEHIND   (1U<<6)  /* (?<=a|bc) */
//C     #define ONIG_SYN_CAPTURE_ONLY_NAMED_GROUP        (1U<<7)  /* see doc/RE */
//C     #define ONIG_SYN_ALLOW_MULTIPLEX_DEFINITION_NAME (1U<<8)  /* (?<x>)(?<x>) */
//C     #define ONIG_SYN_FIXED_INTERVAL_IS_GREEDY_ONLY   (1U<<9)  /* a{n}?=(?:a{n})? */

/* syntax (behavior) in char class [...] */
//C     #define ONIG_SYN_NOT_NEWLINE_IN_NEGATIVE_CC      (1U<<20) /* [^...] */
//C     #define ONIG_SYN_BACKSLASH_ESCAPE_IN_CC          (1U<<21) /* [..\w..] etc.. */
//C     #define ONIG_SYN_ALLOW_EMPTY_RANGE_IN_CC         (1U<<22)
//C     #define ONIG_SYN_ALLOW_DOUBLE_RANGE_OP_IN_CC     (1U<<23) /* [0-9-a]=[0-9\-a] */
/* syntax (behavior) warning */
//C     #define ONIG_SYN_WARN_CC_OP_NOT_ESCAPED          (1U<<24) /* [,-,] */
//C     #define ONIG_SYN_WARN_REDUNDANT_NESTED_REPEAT    (1U<<25) /* (?:a*)+ */

/* meta character specifiers (onig_set_meta_char()) */
//C     #define ONIG_META_CHAR_ESCAPE               0
//C     #define ONIG_META_CHAR_ANYCHAR              1
const ONIG_META_CHAR_ESCAPE = 0;
//C     #define ONIG_META_CHAR_ANYTIME              2
const ONIG_META_CHAR_ANYCHAR = 1;
//C     #define ONIG_META_CHAR_ZERO_OR_ONE_TIME     3
const ONIG_META_CHAR_ANYTIME = 2;
//C     #define ONIG_META_CHAR_ONE_OR_MORE_TIME     4
const ONIG_META_CHAR_ZERO_OR_ONE_TIME = 3;
//C     #define ONIG_META_CHAR_ANYCHAR_ANYTIME      5
const ONIG_META_CHAR_ONE_OR_MORE_TIME = 4;

const ONIG_META_CHAR_ANYCHAR_ANYTIME = 5;
//C     #define ONIG_INEFFECTIVE_META_CHAR          0

const ONIG_INEFFECTIVE_META_CHAR = 0;
/* error codes */
//C     #define ONIG_IS_PATTERN_ERROR(ecode)   ((ecode) <= -100 && (ecode) > -1000)
/* normal return */
//C     #define ONIG_NORMAL                                            0
//C     #define ONIG_MISMATCH                                         -1
const ONIG_NORMAL = 0;
//C     #define ONIG_NO_SUPPORT_CONFIG                                -2
const ONIG_MISMATCH = -1;

const ONIG_NO_SUPPORT_CONFIG = -2;
/* internal error */
//C     #define ONIGERR_MEMORY                                         -5
//C     #define ONIGERR_TYPE_BUG                                       -6
const ONIGERR_MEMORY = -5;
//C     #define ONIGERR_PARSER_BUG                                    -11
const ONIGERR_TYPE_BUG = -6;
//C     #define ONIGERR_STACK_BUG                                     -12
const ONIGERR_PARSER_BUG = -11;
//C     #define ONIGERR_UNDEFINED_BYTECODE                            -13
const ONIGERR_STACK_BUG = -12;
//C     #define ONIGERR_UNEXPECTED_BYTECODE                           -14
const ONIGERR_UNDEFINED_BYTECODE = -13;
//C     #define ONIGERR_MATCH_STACK_LIMIT_OVER                        -15
const ONIGERR_UNEXPECTED_BYTECODE = -14;
//C     #define ONIGERR_DEFAULT_ENCODING_IS_NOT_SETTED                -21
const ONIGERR_MATCH_STACK_LIMIT_OVER = -15;
//C     #define ONIGERR_SPECIFIED_ENCODING_CANT_CONVERT_TO_WIDE_CHAR  -22
const ONIGERR_DEFAULT_ENCODING_IS_NOT_SETTED = -21;
/* general error */
const ONIGERR_SPECIFIED_ENCODING_CANT_CONVERT_TO_WIDE_CHAR = -22;
//C     #define ONIGERR_INVALID_ARGUMENT                              -30 
/* syntax error */
const ONIGERR_INVALID_ARGUMENT = -30;
//C     #define ONIGERR_END_PATTERN_AT_LEFT_BRACE                    -100
//C     #define ONIGERR_END_PATTERN_AT_LEFT_BRACKET                  -101
const ONIGERR_END_PATTERN_AT_LEFT_BRACE = -100;
//C     #define ONIGERR_EMPTY_CHAR_CLASS                             -102
const ONIGERR_END_PATTERN_AT_LEFT_BRACKET = -101;
//C     #define ONIGERR_PREMATURE_END_OF_CHAR_CLASS                  -103
const ONIGERR_EMPTY_CHAR_CLASS = -102;
//C     #define ONIGERR_END_PATTERN_AT_ESCAPE                        -104
const ONIGERR_PREMATURE_END_OF_CHAR_CLASS = -103;
//C     #define ONIGERR_END_PATTERN_AT_META                          -105
const ONIGERR_END_PATTERN_AT_ESCAPE = -104;
//C     #define ONIGERR_END_PATTERN_AT_CONTROL                       -106
const ONIGERR_END_PATTERN_AT_META = -105;
//C     #define ONIGERR_META_CODE_SYNTAX                             -108
const ONIGERR_END_PATTERN_AT_CONTROL = -106;
//C     #define ONIGERR_CONTROL_CODE_SYNTAX                          -109
const ONIGERR_META_CODE_SYNTAX = -108;
//C     #define ONIGERR_CHAR_CLASS_VALUE_AT_END_OF_RANGE             -110
const ONIGERR_CONTROL_CODE_SYNTAX = -109;
//C     #define ONIGERR_CHAR_CLASS_VALUE_AT_START_OF_RANGE           -111
const ONIGERR_CHAR_CLASS_VALUE_AT_END_OF_RANGE = -110;
//C     #define ONIGERR_UNMATCHED_RANGE_SPECIFIER_IN_CHAR_CLASS      -112
const ONIGERR_CHAR_CLASS_VALUE_AT_START_OF_RANGE = -111;
//C     #define ONIGERR_TARGET_OF_REPEAT_OPERATOR_NOT_SPECIFIED      -113
const ONIGERR_UNMATCHED_RANGE_SPECIFIER_IN_CHAR_CLASS = -112;
//C     #define ONIGERR_TARGET_OF_REPEAT_OPERATOR_INVALID            -114
const ONIGERR_TARGET_OF_REPEAT_OPERATOR_NOT_SPECIFIED = -113;
//C     #define ONIGERR_NESTED_REPEAT_OPERATOR                       -115
const ONIGERR_TARGET_OF_REPEAT_OPERATOR_INVALID = -114;
//C     #define ONIGERR_UNMATCHED_CLOSE_PARENTHESIS                  -116
const ONIGERR_NESTED_REPEAT_OPERATOR = -115;
//C     #define ONIGERR_END_PATTERN_WITH_UNMATCHED_PARENTHESIS       -117
const ONIGERR_UNMATCHED_CLOSE_PARENTHESIS = -116;
//C     #define ONIGERR_END_PATTERN_IN_GROUP                         -118
const ONIGERR_END_PATTERN_WITH_UNMATCHED_PARENTHESIS = -117;
//C     #define ONIGERR_UNDEFINED_GROUP_OPTION                       -119
const ONIGERR_END_PATTERN_IN_GROUP = -118;
//C     #define ONIGERR_INVALID_POSIX_BRACKET_TYPE                   -121
const ONIGERR_UNDEFINED_GROUP_OPTION = -119;
//C     #define ONIGERR_INVALID_LOOK_BEHIND_PATTERN                  -122
const ONIGERR_INVALID_POSIX_BRACKET_TYPE = -121;
//C     #define ONIGERR_INVALID_REPEAT_RANGE_PATTERN                 -123
const ONIGERR_INVALID_LOOK_BEHIND_PATTERN = -122;
/* values error (syntax error) */
const ONIGERR_INVALID_REPEAT_RANGE_PATTERN = -123;
//C     #define ONIGERR_TOO_BIG_NUMBER                               -200
//C     #define ONIGERR_TOO_BIG_NUMBER_FOR_REPEAT_RANGE              -201
const ONIGERR_TOO_BIG_NUMBER = -200;
//C     #define ONIGERR_UPPER_SMALLER_THAN_LOWER_IN_REPEAT_RANGE     -202
const ONIGERR_TOO_BIG_NUMBER_FOR_REPEAT_RANGE = -201;
//C     #define ONIGERR_EMPTY_RANGE_IN_CHAR_CLASS                    -203
const ONIGERR_UPPER_SMALLER_THAN_LOWER_IN_REPEAT_RANGE = -202;
//C     #define ONIGERR_MISMATCH_CODE_LENGTH_IN_CLASS_RANGE          -204
const ONIGERR_EMPTY_RANGE_IN_CHAR_CLASS = -203;
//C     #define ONIGERR_TOO_MANY_MULTI_BYTE_RANGES                   -205
const ONIGERR_MISMATCH_CODE_LENGTH_IN_CLASS_RANGE = -204;
//C     #define ONIGERR_TOO_SHORT_MULTI_BYTE_STRING                  -206
const ONIGERR_TOO_MANY_MULTI_BYTE_RANGES = -205;
//C     #define ONIGERR_TOO_BIG_BACKREF_NUMBER                       -207
const ONIGERR_TOO_SHORT_MULTI_BYTE_STRING = -206;
//C     #define ONIGERR_INVALID_BACKREF                              -208
const ONIGERR_TOO_BIG_BACKREF_NUMBER = -207;
//C     #define ONIGERR_NUMBERED_BACKREF_OR_CALL_NOT_ALLOWED         -209
const ONIGERR_INVALID_BACKREF = -208;
//C     #define ONIGERR_TOO_LONG_WIDE_CHAR_VALUE                     -212
const ONIGERR_NUMBERED_BACKREF_OR_CALL_NOT_ALLOWED = -209;
//C     #define ONIGERR_EMPTY_GROUP_NAME                             -214
const ONIGERR_TOO_LONG_WIDE_CHAR_VALUE = -212;
//C     #define ONIGERR_INVALID_GROUP_NAME                           -215
const ONIGERR_EMPTY_GROUP_NAME = -214;
//C     #define ONIGERR_INVALID_CHAR_IN_GROUP_NAME                   -216
const ONIGERR_INVALID_GROUP_NAME = -215;
//C     #define ONIGERR_UNDEFINED_NAME_REFERENCE                     -217
const ONIGERR_INVALID_CHAR_IN_GROUP_NAME = -216;
//C     #define ONIGERR_UNDEFINED_GROUP_REFERENCE                    -218
const ONIGERR_UNDEFINED_NAME_REFERENCE = -217;
//C     #define ONIGERR_MULTIPLEX_DEFINED_NAME                       -219
const ONIGERR_UNDEFINED_GROUP_REFERENCE = -218;
//C     #define ONIGERR_MULTIPLEX_DEFINITION_NAME_CALL               -220
const ONIGERR_MULTIPLEX_DEFINED_NAME = -219;
//C     #define ONIGERR_NEVER_ENDING_RECURSION                       -221
const ONIGERR_MULTIPLEX_DEFINITION_NAME_CALL = -220;
//C     #define ONIGERR_GROUP_NUMBER_OVER_FOR_CAPTURE_HISTORY        -222
const ONIGERR_NEVER_ENDING_RECURSION = -221;
//C     #define ONIGERR_INVALID_CHAR_PROPERTY_NAME                   -223
const ONIGERR_GROUP_NUMBER_OVER_FOR_CAPTURE_HISTORY = -222;
//C     #define ONIGERR_INVALID_CODE_POINT_VALUE                     -400
const ONIGERR_INVALID_CHAR_PROPERTY_NAME = -223;
//C     #define ONIGERR_INVALID_WIDE_CHAR_VALUE                      -400
const ONIGERR_INVALID_CODE_POINT_VALUE = -400;
//C     #define ONIGERR_TOO_BIG_WIDE_CHAR_VALUE                      -401
const ONIGERR_INVALID_WIDE_CHAR_VALUE = -400;
//C     #define ONIGERR_NOT_SUPPORTED_ENCODING_COMBINATION           -402
const ONIGERR_TOO_BIG_WIDE_CHAR_VALUE = -401;
//C     #define ONIGERR_INVALID_COMBINATION_OF_OPTIONS               -403
const ONIGERR_NOT_SUPPORTED_ENCODING_COMBINATION = -402;

const ONIGERR_INVALID_COMBINATION_OF_OPTIONS = -403;
/* errors related to thread */
//C     #define ONIGERR_OVER_THREAD_PASS_LIMIT_COUNT                -1001

const ONIGERR_OVER_THREAD_PASS_LIMIT_COUNT = -1001;

/* must be smaller than BIT_STATUS_BITS_NUM (unsigned int * 8) */
//C     #define ONIG_MAX_CAPTURE_HISTORY_GROUP   31
//C     #define ONIG_IS_CAPTURE_HISTORY_GROUP(r, i)   ((i) <= ONIG_MAX_CAPTURE_HISTORY_GROUP && (r)->list && (r)->list[i])
const ONIG_MAX_CAPTURE_HISTORY_GROUP = 31;

//C     typedef struct OnigCaptureTreeNodeStruct {
//C       int group;   /* group number */
//C       int beg;
//C       int end;
//C       int allocated;
//C       int num_childs;
//C       struct OnigCaptureTreeNodeStruct** childs;
//C     } OnigCaptureTreeNode;
struct OnigCaptureTreeNodeStruct
{
    int group;
    int beg;
    int end;
    int allocated;
    int num_childs;
    OnigCaptureTreeNodeStruct **childs;
}
alias OnigCaptureTreeNodeStruct OnigCaptureTreeNode;

/* match result region type */
//C     struct re_registers {
//C       int  allocated;
//C       int  num_regs;
//C       int* beg;
//C       int* end;
  /* extended */
//C       OnigCaptureTreeNode* history_root;  /* capture history tree root */
//C     };
struct re_registers
{
    int allocated;
    int num_regs;
    int *beg;
    int *end;
    OnigCaptureTreeNode *history_root;
}

/* capture tree traverse */
//C     #define ONIG_TRAVERSE_CALLBACK_AT_FIRST   1
//C     #define ONIG_TRAVERSE_CALLBACK_AT_LAST    2
const ONIG_TRAVERSE_CALLBACK_AT_FIRST = 1;
//C     #define ONIG_TRAVERSE_CALLBACK_AT_BOTH   ( ONIG_TRAVERSE_CALLBACK_AT_FIRST | ONIG_TRAVERSE_CALLBACK_AT_LAST )
const ONIG_TRAVERSE_CALLBACK_AT_LAST = 2;


//C     #define ONIG_REGION_NOTPOS            -1

const ONIG_REGION_NOTPOS = -1;
//C     typedef struct re_registers   OnigRegion;
alias re_registers OnigRegion;

//C     typedef struct {
//C       OnigEncoding enc;
//C       OnigUChar* par;
//C       OnigUChar* par_end;
//C     } OnigErrorInfo;
struct _N4
{
    OnigEncoding enc;
    OnigUChar *par;
    OnigUChar *par_end;
}
alias _N4 OnigErrorInfo;

//C     typedef struct {
//C       int lower;
//C       int upper;
//C     } OnigRepeatRange;
struct _N5
{
    int lower;
    int upper;
}
alias _N5 OnigRepeatRange;

//C     typedef void (*OnigWarnFunc) P_((const char* s));
alias void  function(char *s)OnigWarnFunc;
//C     extern void onig_null_warn P_((const char* s));
void  onig_null_warn(char *s);
//C     #define ONIG_NULL_WARN       onig_null_warn

alias onig_null_warn ONIG_NULL_WARN;
//C     #define ONIG_CHAR_TABLE_SIZE   256

const ONIG_CHAR_TABLE_SIZE = 256;
/* regex_t state */
//C     #define ONIG_STATE_NORMAL              0
//C     #define ONIG_STATE_SEARCHING           1
const ONIG_STATE_NORMAL = 0;
//C     #define ONIG_STATE_COMPILING          -1
const ONIG_STATE_SEARCHING = 1;
//C     #define ONIG_STATE_MODIFY             -2
const ONIG_STATE_COMPILING = -1;

const ONIG_STATE_MODIFY = -2;
//C     #define ONIG_STATE(reg)   ((reg)->state > 0 ? ONIG_STATE_SEARCHING : (reg)->state)

//C     typedef struct re_pattern_buffer {
  /* common members of BBuf(bytes-buffer) */
//C       unsigned char* p;         /* compiled pattern */
//C       unsigned int used;        /* used space for p */
//C       unsigned int alloc;       /* allocated space for p */

//C       int state;                     /* normal, searching, compiling */
//C       int num_mem;                   /* used memory(...) num counted from 1 */
//C       int num_repeat;                /* OP_REPEAT/OP_REPEAT_NG id-counter */
//C       int num_null_check;            /* OP_NULL_CHECK_START/END id counter */
//C       int num_comb_exp_check;        /* combination explosion check */
//C       int num_call;                  /* number of subexp call */
//C       unsigned int capture_history;  /* (?@...) flag (1-31) */
//C       unsigned int bt_mem_start;     /* need backtrack flag */
//C       unsigned int bt_mem_end;       /* need backtrack flag */
//C       int stack_pop_level;
//C       int repeat_range_alloc;
//C       OnigRepeatRange* repeat_range;

//C       OnigEncoding      enc;
//C       OnigOptionType    options;
//C       OnigSyntaxType*   syntax;
//C       OnigCaseFoldType  case_fold_flag;
//C       void*             name_table;

  /* optimization info (string search, char-map and anchors) */
//C       int            optimize;          /* optimize flag */
//C       int            threshold_len;     /* search str-length for apply optimize */
//C       int            anchor;            /* BEGIN_BUF, BEGIN_POS, (SEMI_)END_BUF */
//C       OnigDistance   anchor_dmin;       /* (SEMI_)END_BUF anchor distance */
//C       OnigDistance   anchor_dmax;       /* (SEMI_)END_BUF anchor distance */
//C       int            sub_anchor;        /* start-anchor for exact or map */
//C       unsigned char *exact;
//C       unsigned char *exact_end;
//C       unsigned char  map[ONIG_CHAR_TABLE_SIZE]; /* used as BM skip or char-map */
//C       int           *int_map;                   /* BM skip for exact_len > 255 */
//C       int           *int_map_backward;          /* BM skip for backward search */
//C       OnigDistance   dmin;                      /* min-distance of exact or map */
//C       OnigDistance   dmax;                      /* max-distance of exact or map */

  /* regex_t link chain */
//C       struct re_pattern_buffer* chain;  /* escape compile-conflict */
//C     } OnigRegexType;
struct re_pattern_buffer
{
    ubyte *p;
    uint used;
    uint alloc;
    int state;
    int num_mem;
    int num_repeat;
    int num_null_check;
    int num_comb_exp_check;
    int num_call;
    uint capture_history;
    uint bt_mem_start;
    uint bt_mem_end;
    int stack_pop_level;
    int repeat_range_alloc;
    OnigRepeatRange *repeat_range;
    OnigEncoding enc;
    OnigOptionType options;
    OnigSyntaxType *syntax;
    OnigCaseFoldType case_fold_flag;
    void *name_table;
    int optimize;
    int threshold_len;
    int anchor;
    OnigDistance anchor_dmin;
    OnigDistance anchor_dmax;
    int sub_anchor;
    ubyte *exact;
    ubyte *exact_end;
    ubyte [256]map;
    int *int_map;
    int *int_map_backward;
    OnigDistance dmin;
    OnigDistance dmax;
    re_pattern_buffer *chain;
}
alias re_pattern_buffer OnigRegexType;

//C     typedef OnigRegexType*  OnigRegex;
alias OnigRegexType *OnigRegex;

//C     #ifndef ONIG_ESCAPE_REGEX_T_COLLISION
//C       typedef OnigRegexType  regex_t;
alias OnigRegexType regex_t;
//C     #endif


//C     typedef struct {
//C       int             num_of_elements;
//C       OnigEncoding    pattern_enc;
//C       OnigEncoding    target_enc;
//C       OnigSyntaxType* syntax;
//C       OnigOptionType  option;
//C       OnigCaseFoldType   case_fold_flag;
//C     } OnigCompileInfo;
struct _N6
{
    int num_of_elements;
    OnigEncoding pattern_enc;
    OnigEncoding target_enc;
    OnigSyntaxType *syntax;
    OnigOptionType option;
    OnigCaseFoldType case_fold_flag;
}
alias _N6 OnigCompileInfo;

/* Oniguruma Native API */
//C     ONIG_EXTERN
//C     int onig_init P_((void));
export int  onig_init();
//C     ONIG_EXTERN
//C     int onig_error_code_to_str PV_((OnigUChar* s, int err_code, ...));
export int  onig_error_code_to_str(OnigUChar* s, int err_code, ...);
//C     ONIG_EXTERN
//C     void onig_set_warn_func P_((OnigWarnFunc f));
export void  onig_set_warn_func(OnigWarnFunc f);
//C     ONIG_EXTERN
//C     void onig_set_verb_warn_func P_((OnigWarnFunc f));
export void  onig_set_verb_warn_func(OnigWarnFunc f);
//C     ONIG_EXTERN
//C     int onig_new P_((OnigRegex*, const OnigUChar* pattern, const OnigUChar* pattern_end, OnigOptionType option, OnigEncoding enc, OnigSyntaxType* syntax, OnigErrorInfo* einfo));
export int  onig_new(OnigRegex *, OnigUChar *pattern, OnigUChar *pattern_end, OnigOptionType option, OnigEncoding enc, OnigSyntaxType *syntax, OnigErrorInfo *einfo);
//C     ONIG_EXTERN
//C     int onig_new_deluxe P_((OnigRegex* reg, const OnigUChar* pattern, const OnigUChar* pattern_end, OnigCompileInfo* ci, OnigErrorInfo* einfo));
export int  onig_new_deluxe(OnigRegex *reg, OnigUChar *pattern, OnigUChar *pattern_end, OnigCompileInfo *ci, OnigErrorInfo *einfo);
//C     ONIG_EXTERN
//C     void onig_free P_((OnigRegex));
export void  onig_free(OnigRegex );
//C     ONIG_EXTERN
//C     int onig_recompile P_((OnigRegex, const OnigUChar* pattern, const OnigUChar* pattern_end, OnigOptionType option, OnigEncoding enc, OnigSyntaxType* syntax, OnigErrorInfo* einfo));
export int  onig_recompile(OnigRegex , OnigUChar *pattern, OnigUChar *pattern_end, OnigOptionType option, OnigEncoding enc, OnigSyntaxType *syntax, OnigErrorInfo *einfo);
//C     ONIG_EXTERN
//C     int onig_recompile_deluxe P_((OnigRegex reg, const OnigUChar* pattern, const OnigUChar* pattern_end, OnigCompileInfo* ci, OnigErrorInfo* einfo));
export int  onig_recompile_deluxe(OnigRegex reg, OnigUChar *pattern, OnigUChar *pattern_end, OnigCompileInfo *ci, OnigErrorInfo *einfo);
//C     ONIG_EXTERN
//C     int onig_search P_((OnigRegex, const OnigUChar* str, const OnigUChar* end, const OnigUChar* start, const OnigUChar* range, OnigRegion* region, OnigOptionType option));
export int  onig_search(OnigRegex , OnigUChar *str, OnigUChar *end, OnigUChar *start, OnigUChar *range, OnigRegion *region, OnigOptionType option);
//C     ONIG_EXTERN
//C     int onig_match P_((OnigRegex, const OnigUChar* str, const OnigUChar* end, const OnigUChar* at, OnigRegion* region, OnigOptionType option));
export int  onig_match(OnigRegex , OnigUChar *str, OnigUChar *end, OnigUChar *at, OnigRegion *region, OnigOptionType option);
//C     ONIG_EXTERN
//C     OnigRegion* onig_region_new P_((void));
export OnigRegion * onig_region_new();
//C     ONIG_EXTERN
//C     void onig_region_init P_((OnigRegion* region));
export void  onig_region_init(OnigRegion *region);
//C     ONIG_EXTERN
//C     void onig_region_free P_((OnigRegion* region, int free_self));
export void  onig_region_free(OnigRegion *region, int free_self);
//C     ONIG_EXTERN
//C     void onig_region_copy P_((OnigRegion* to, OnigRegion* from));
export void  onig_region_copy(OnigRegion *to, OnigRegion *from);
//C     ONIG_EXTERN
//C     void onig_region_clear P_((OnigRegion* region));
export void  onig_region_clear(OnigRegion *region);
//C     ONIG_EXTERN
//C     int onig_region_resize P_((OnigRegion* region, int n));
export int  onig_region_resize(OnigRegion *region, int n);
//C     ONIG_EXTERN
//C     int onig_region_set P_((OnigRegion* region, int at, int beg, int end));
export int  onig_region_set(OnigRegion *region, int at, int beg, int end);
//C     ONIG_EXTERN
//C     int onig_name_to_group_numbers P_((OnigRegex reg, const OnigUChar* name, const OnigUChar* name_end, int** nums));
export int  onig_name_to_group_numbers(OnigRegex reg, OnigUChar *name, OnigUChar *name_end, int **nums);
//C     ONIG_EXTERN
//C     int onig_name_to_backref_number P_((OnigRegex reg, const OnigUChar* name, const OnigUChar* name_end, OnigRegion *region));
export int  onig_name_to_backref_number(OnigRegex reg, OnigUChar *name, OnigUChar *name_end, OnigRegion *region);
//C     ONIG_EXTERN
//C     int onig_foreach_name P_((OnigRegex reg, int (*func)(const OnigUChar*, const OnigUChar*,int,int*,OnigRegex,void*), void* arg));
export int  onig_foreach_name(OnigRegex reg, int  function(OnigUChar *, OnigUChar *, int , int *, OnigRegex , void *)func, void *arg);
//C     ONIG_EXTERN
//C     int onig_number_of_names P_((OnigRegex reg));
export int  onig_number_of_names(OnigRegex reg);
//C     ONIG_EXTERN
//C     int onig_number_of_captures P_((OnigRegex reg));
export int  onig_number_of_captures(OnigRegex reg);
//C     ONIG_EXTERN
//C     int onig_number_of_capture_histories P_((OnigRegex reg));
export int  onig_number_of_capture_histories(OnigRegex reg);
//C     ONIG_EXTERN
//C     OnigCaptureTreeNode* onig_get_capture_tree P_((OnigRegion* region));
export OnigCaptureTreeNode * onig_get_capture_tree(OnigRegion *region);
//C     ONIG_EXTERN
//C     int onig_capture_tree_traverse P_((OnigRegion* region, int at, int(*callback_func)(int,int,int,int,int,void*), void* arg));
export int  onig_capture_tree_traverse(OnigRegion *region, int at, int  function(int , int , int , int , int , void *)callback_func, void *arg);
//C     ONIG_EXTERN
//C     int onig_noname_group_capture_is_active P_((OnigRegex reg));
export int  onig_noname_group_capture_is_active(OnigRegex reg);
//C     ONIG_EXTERN
//C     OnigEncoding onig_get_encoding P_((OnigRegex reg));
export OnigEncoding  onig_get_encoding(OnigRegex reg);
//C     ONIG_EXTERN
//C     OnigOptionType onig_get_options P_((OnigRegex reg));
export OnigOptionType  onig_get_options(OnigRegex reg);
//C     ONIG_EXTERN
//C     OnigCaseFoldType onig_get_case_fold_flag P_((OnigRegex reg));
export OnigCaseFoldType  onig_get_case_fold_flag(OnigRegex reg);
//C     ONIG_EXTERN
//C     OnigSyntaxType* onig_get_syntax P_((OnigRegex reg));
export OnigSyntaxType * onig_get_syntax(OnigRegex reg);
//C     ONIG_EXTERN
//C     int onig_set_default_syntax P_((OnigSyntaxType* syntax));
export int  onig_set_default_syntax(OnigSyntaxType *syntax);
//C     ONIG_EXTERN
//C     void onig_copy_syntax P_((OnigSyntaxType* to, OnigSyntaxType* from));
export void  onig_copy_syntax(OnigSyntaxType *to, OnigSyntaxType *from);
//C     ONIG_EXTERN
//C     unsigned int onig_get_syntax_op P_((OnigSyntaxType* syntax));
export uint  onig_get_syntax_op(OnigSyntaxType *syntax);
//C     ONIG_EXTERN
//C     unsigned int onig_get_syntax_op2 P_((OnigSyntaxType* syntax));
export uint  onig_get_syntax_op2(OnigSyntaxType *syntax);
//C     ONIG_EXTERN
//C     unsigned int onig_get_syntax_behavior P_((OnigSyntaxType* syntax));
export uint  onig_get_syntax_behavior(OnigSyntaxType *syntax);
//C     ONIG_EXTERN
//C     OnigOptionType onig_get_syntax_options P_((OnigSyntaxType* syntax));
export OnigOptionType  onig_get_syntax_options(OnigSyntaxType *syntax);
//C     ONIG_EXTERN
//C     void onig_set_syntax_op P_((OnigSyntaxType* syntax, unsigned int op));
export void  onig_set_syntax_op(OnigSyntaxType *syntax, uint op);
//C     ONIG_EXTERN
//C     void onig_set_syntax_op2 P_((OnigSyntaxType* syntax, unsigned int op2));
export void  onig_set_syntax_op2(OnigSyntaxType *syntax, uint op2);
//C     ONIG_EXTERN
//C     void onig_set_syntax_behavior P_((OnigSyntaxType* syntax, unsigned int behavior));
export void  onig_set_syntax_behavior(OnigSyntaxType *syntax, uint behavior);
//C     ONIG_EXTERN
//C     void onig_set_syntax_options P_((OnigSyntaxType* syntax, OnigOptionType options));
export void  onig_set_syntax_options(OnigSyntaxType *syntax, OnigOptionType options);
//C     ONIG_EXTERN
//C     int onig_set_meta_char P_((OnigSyntaxType* syntax, unsigned int what, OnigCodePoint code));
export int  onig_set_meta_char(OnigSyntaxType *syntax, uint what, OnigCodePoint code);
//C     ONIG_EXTERN
//C     void onig_copy_encoding P_((OnigEncoding to, OnigEncoding from));
export void  onig_copy_encoding(OnigEncoding to, OnigEncoding from);
//C     ONIG_EXTERN
//C     OnigCaseFoldType onig_get_default_case_fold_flag P_((void));
export OnigCaseFoldType  onig_get_default_case_fold_flag();
//C     ONIG_EXTERN
//C     int onig_set_default_case_fold_flag P_((OnigCaseFoldType case_fold_flag));
export int  onig_set_default_case_fold_flag(OnigCaseFoldType case_fold_flag);
//C     ONIG_EXTERN
//C     unsigned int onig_get_match_stack_limit_size P_((void));
export uint  onig_get_match_stack_limit_size();
//C     ONIG_EXTERN
//C     int onig_set_match_stack_limit_size P_((unsigned int size));
export int  onig_set_match_stack_limit_size(uint size);
//C     ONIG_EXTERN
//C     int onig_end P_((void));
export int  onig_end();
//C     ONIG_EXTERN
//C     const char* onig_version P_((void));
export char * onig_version();
//C     ONIG_EXTERN
//C     const char* onig_copyright P_((void));
export char * onig_copyright();

//C     #ifdef __cplusplus
//C     }
//C     #endif

//C     #endif /* ONIGURUMA_H */
