module nscr.plugin;

private import std.string;

/// コマンドの区切り文字
static const char[] commandsep = " ";

/// パラメータの区切り文字
static const char[] paramsep = "|";

/// 改行文字
static const char[] linesep = "\\";

/// リストの区切り文字
static const char[] listsep = "|";

/// コマンドを取得する。
/**
    @param  paramstr パラメータ文字列
    @return コマンド
**/
char[] getCommand(char[] paramstr){
    int pos = std.string.find(paramstr, commandsep);
    if(pos == -1)
        pos = paramstr.length;
    return paramstr[0..pos];
}

/// パラメータを取得する。
/**
    @param  paramstr パラメータ文字列
    @return パラメータ
**/
char[][] getArgs(char[] paramstr){
    int pos = std.string.find(paramstr, commandsep);
    if(pos == -1)
        return null;
    return std.string.split(paramstr[pos+1..$], paramsep);
}

/// 単一パラメータを取得する。
/**
    @param  paramstr パラメータ文字列
    @return パラメータ
**/
char[][] getSingleArg(char[] paramstr){
    int pos = std.string.find(paramstr, commandsep);
    if(pos == -1)
        return null;
    return [paramstr[pos+1..$]];
}
