module nscrdll;

private import std.c.windows.windows;
private import std.windows.charset;
private import std.string;

private import nscr.result;
private import nscr.plugin;

private import nscronig.onig;
private import nscronig.meddle;

private int major = 0;
private int minor = 0;

extern(C)
{
    export BOOL NScrPlugInMain(HINSTANCE hinstance, HWND hwnd, char *param, int *ret_int, char *ret_str)
    {
        char[] paramstr = fromMBSz(param);
        char[] command = getCommand(paramstr);
        attach(ret_int, ret_str);
        
        try{
            switch(command){
            case "setPattern":
                setret(invoke(&setPattern, getSingleArg(paramstr)));
                break;

            case "setOption":
                setret(invoke(&setOption, getArgs(paramstr)));
                break;

            case "find":
                setret(invoke(&nscronig.onig.find, getSingleArg(paramstr)));
                break;

            case "next":
                setret(invoke(&next));
                break;

            case "end":
                setret(invoke(&end));
                break;

            case "version":
                setret(invoke(&getVersion));
                break;

            case "dllversion":
                setret(Result(major * 10 + minor, join([toString(major), toString(minor)], ".")));
                break;

            default:
                setret(false, paramstr);
                break;
            }
        }
        catch(Exception e){
            setret(false, e.toString());
        }
        return false;
    }
}
