module nscronig.meddle;

private import std.file;
private import std.path;

typedef char[][] strings;
/// meddlesome invoker
R invoke(R, T...)(R function(T) func, char[][] args){
    static if(is(T[0] == char[][])){
        return func(args);
    }
    else{
    	T tuple;
    	foreach(i, t; tuple){
    		if(i >= args.length) break;
    		tuple[i] = meddle!(typeof(tuple[i]))(args[i]);
    	}
    	return func(tuple);
    }
}


/// meddlesome invoker
R invoke(Dummy=void, R, T...)(R delegate(T) func, char[][] args){
    static if(is(T[0] == char[][])){
        return func(args);
    }
    else{
    	T tuple;
    	foreach(i, t; tuple){
    		if(i >= args.length) break;
    		tuple[i] = meddle!(typeof(tuple[i]))(args[i]);
    	}
    	return func(tuple);
    }
}


/// meddlesome invoker
R invoke(R)(R function() func){
	return func();
}


/// general meddling
R meddle(R)(R arg){
	return arg;
}


/// str to int meddling
R meddle(R : int)(char[] arg){
	return std.conv.toInt(arg);
}


typedef char[] sjistext;
/// str to ShiftJIS-text meddling
R meddle(R : sjistext)(char[] arg){
    return cast(sjistext)std.string.toString(std.windows.charset.toMBSz(arg));
}


unittest
{
	char[] strcat2(char[] str1, char[] str2, char[] str3){
		return str1 ~ str2 ~ str3;
	}
	void main(){
		assert(invoke(&strcat2, ["strcat2", " is ", "OK!"]) == "strcat2 is OK!", "strcat2 is NG...");
	}
}
